% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/install_and_config.R
\name{AifeducationConfiguration}
\alias{AifeducationConfiguration}
\title{R6 class for settting the global machine learning framework.}
\value{
The function does nothing return. It is used for its side effects.
}
\description{
R6 class for settting the global machine learning framework.

R6 class for settting the global machine learning framework.
}
\details{
R6 class for setting the global machine learning framework to 'PyTorch' or
'tensorflow' depending of the available version of 'keras'.
}
\note{
This function must be called directly after loading 'aifeducation' to take effect.

Please note that using classifier objects with 'PyTorch' requires keras of
at least version 3. If you have an older version 'tensorflow' is used.
}
\seealso{
Other Installation and Configuration: 
\code{\link{aifeducation_config}},
\code{\link{check_aif_py_modules}()},
\code{\link{install_py_modules}()},
\code{\link{set_config_cpu_only}()},
\code{\link{set_config_gpu_low_memory}()},
\code{\link{set_config_os_environ_logger}()},
\code{\link{set_config_tf_logger}()},
\code{\link{set_transformers_logger}()}
}
\concept{Installation and Configuration}
\section{Methods}{
\subsection{Public methods}{
\itemize{
\item \href{#method-aifeducationConfiguration-get_framework}{\code{AifeducationConfiguration$get_framework()}}
\item \href{#method-aifeducationConfiguration-set_global_ml_backend}{\code{AifeducationConfiguration$set_global_ml_backend()}}
\item \href{#method-aifeducationConfiguration-global_framework_set}{\code{AifeducationConfiguration$global_framework_set()}}
\item \href{#method-aifeducationConfiguration-clone}{\code{AifeducationConfiguration$clone()}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-aifeducationConfiguration-get_framework"></a>}}
\if{latex}{\out{\hypertarget{method-aifeducationConfiguration-get_framework}{}}}
\subsection{Method \code{get_framework()}}{
Method for requesting the used machine learning framework.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{AifeducationConfiguration$get_framework()}\if{html}{\out{</div>}}
}

\subsection{Returns}{
Returns a \code{list} containing the used machine learning framework
for \link{TextEmbeddingModel}s as well as for \link{TextEmbeddingClassifierNeuralNet}.
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-aifeducationConfiguration-set_global_ml_backend"></a>}}
\if{latex}{\out{\hypertarget{method-aifeducationConfiguration-set_global_ml_backend}{}}}
\subsection{Method \code{set_global_ml_backend()}}{
Method for setting machine learning framework.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{AifeducationConfiguration$set_global_ml_backend(backend)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{backend}}{\code{string} Framework to use for training and inference.
\code{backend="tensorflow"} for 'tensorflow' and \code{backend="pytorch"}
for 'PyTorch'.}
}
\if{html}{\out{</div>}}
}
\subsection{Returns}{
This method does nothing return. It is used for setting the global
configuration of 'aifeducation'.
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-aifeducationConfiguration-global_framework_set"></a>}}
\if{latex}{\out{\hypertarget{method-aifeducationConfiguration-global_framework_set}{}}}
\subsection{Method \code{global_framework_set()}}{
Method for checking if the global ml framework is set.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{AifeducationConfiguration$global_framework_set()}\if{html}{\out{</div>}}
}

\subsection{Returns}{
Return \code{TRUE} if the global machine learning framework ist set.
Otherwiese \code{FALSE}.
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-aifeducationConfiguration-clone"></a>}}
\if{latex}{\out{\hypertarget{method-aifeducationConfiguration-clone}{}}}
\subsection{Method \code{clone()}}{
The objects of this class are cloneable with this method.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{AifeducationConfiguration$clone(deep = FALSE)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{deep}}{Whether to make a deep clone.}
}
\if{html}{\out{</div>}}
}
}
}
